.386
.model flat,stdcall
option casemap:none

INCLUDE    \masm32\include\windows.inc

INCLUDE    \masm32\include\comdlg32.inc
INCLUDELIB \masm32\lib\comdlg32.lib

; ------ STRUCTS ------
sSEH STRUCT
	OrgEsp		  dd ?
	OrgEbp		  dd ?
	SaveEip 	  dd ?
sSEH ENDS

; ------ EQU'S ------
MIN_KERNEL_SEARCH_BASE	  EQU 070000000h
MAX_API_STRING_LENGTH	  EQU 150

; ------ CONST ------
.CONST
szLoadLibrary	    db	 "LoadLibraryA",0
szGetVersionExA 	 db  "GetVersionExA",0
szGetProcAddress	 db  "GetProcAddress",0

szExitProcess	    db	 "ExitProcess",0

szUser32		  db   "user32",0
szMessageBox	    db	 "MessageBoxA",0
szwsprintf		  db   "wsprintfA",0

szInfoCap		  db   "- Kernel -",0
szInfoText		  db   "The following information were obtained",13,10
			  db   "without the help of an Import Table !",13,10
			  db  13,10
			  db   "Kernel32.dll ImageBase:  0x%08lX",13,10
			  db   "User32.dll ImageBase:  0x%08lX",13,10
			  db  13,10
			  db   "API Addresses:",13,10
			  db   "LoadLibraryA:  0x%08lX",13,10
			  db   "GetProcAddress:  0x%08lX",13,10
			  db   "ExitProcess:  0x%08lX",13,10
			  db  13,10
			  db   "MessageBoxA:  0x%08lX",13,10
			  db   "wsprintfA:  0x%08lX",0

; ------ DATA ------
.DATA

_LoadLibrary	    dd 0
_GetProcAddress 	  dd 0
_ExitProcess	    dd 0
_MessageBox		  dd 0
_wsprintf		  dd 0

cBuff			  db 200 DUP (0)
SEH			  sSEH <0>

dwKernelBase	    dd 0
dwUserBase		  dd 0

; ------ CODE ------
.CODE
main:
	ASSUME FS : NOTHING
	
	;INT 3
	
	;---- GET ImageBase of kernel32.dll ----        

	xor eax, eax
	mov eax, esp	; PUSH dword ptr [ESP]

	;PUSH [ESP]
	CALL GetKernelBase
	OR   EAX, EAX
	JZ   QUIT
	MOV  dwKernelBase, EAX
	
	;---- GET SOME KERNEL API ADDRESSES ----
	;-> LoadLibraryA
	PUSH OFFSET szLoadLibrary
	PUSH dwKernelBase
	CALL GetProcAddr
	OR   EAX, EAX
	JZ   QUIT
	MOV  _LoadLibrary, EAX
	
	;-> GetProcAddress
	PUSH OFFSET szGetProcAddress
	PUSH dwKernelBase
	CALL GetProcAddr
	OR   EAX, EAX
	JZ   QUIT
	MOV  _GetProcAddress, EAX
	
	;-> ExitProcess
	PUSH OFFSET szExitProcess
	PUSH dwKernelBase
	CALL GetProcAddr
	OR   EAX, EAX
	JZ   QUIT
	MOV  _ExitProcess, EAX
	
	;---- LOAD USER32.DLL ----
	PUSH OFFSET szUser32
	CALL _LoadLibrary
	OR   EAX, EAX
	JZ   QUIT
	MOV  dwUserBase, EAX
	
	;---- GET SOME USER API ADDRESSES ----
	;-> MessageBoxA
	PUSH OFFSET szMessageBox
	PUSH dwUserBase
	CALL GetProcAddr
	OR   EAX, EAX
	JZ   QUIT
	MOV  _MessageBox, EAX
	
	;-> wsprintfA
	PUSH OFFSET szwsprintf
	PUSH dwUserBase
	CALL GetProcAddr
	OR   EAX, EAX
	JZ   QUIT
	MOV  _wsprintf, EAX
	
	;---- BUILD AND SHOW THE INFORMATION MSG ----
	PUSH _wsprintf
	PUSH _MessageBox
	PUSH _ExitProcess
	PUSH _GetProcAddress
	PUSH _LoadLibrary
	PUSH dwUserBase
	PUSH dwKernelBase
	
	PUSH OFFSET szInfoText
	PUSH OFFSET cBuff
	CALL _wsprintf
	ADD  ESP, (9 * SIZEOF(DWORD))
	
	PUSH MB_ICONINFORMATION OR MB_SYSTEMMODAL
	PUSH OFFSET szInfoCap
	PUSH OFFSET cBuff
	PUSH 0
	CALL _MessageBox
	
	;---- EXIT ----
	CALL _ExitProcess			  ;)

QUIT:
	RET					    ; exit to OS
	
;---- AN UNUSED IMPORT ----------------------
					    ;  The Win32 Loader of Win2k (maybe also
					    ;  WinNT) won't call EntryPoint of files
					    ;  which don't have an Import Table :(
					    ;  Here a unused Import to make MASM
					    ;  compile an Import Table.

			    PUSH NULL
			    CALL GetOpenFileName
	
; ##############################################
; ##############################################
GetProcAddr PROC USES ESI EDI ECX EBX EDX, dwDllBase : DWORD, szApi : LPSTR

	MOV  ESI, dwDllBase                ;  check PE Signarue
	CMP  WORD PTR [ESI], 5a4dh         ;  IMAGE_DOS_SIGNATURE
	JNZ @@BadExit
	ADD  ESI, [ESI+03Ch]
	CMP  DWORD PTR [ESI], 4550h        ;  IMAGE_NT_SIGNATURE
	JNZ @@BadExit
;............................................................................
	MOV  EDI, [szApi]			     ;  get str len of Api
	MOV  ECX, MAX_API_STRING_LENGTH
	XOR  AL, AL
	REPNZ  SCASB
	MOV  ECX, EDI
	SUB  ECX, [szApi]			     ;  ECX -> Api str len
;............................................................................
	MOV  EDX, [ESI+078h]	  ; trace the export table
	ADD  EDX, dwDllBase	  ; EDX -> Export table


mov ebx, [edx+IMAGE_EXPORT_DIRECTORY.AddressOfNames] ; EBX -> A.o.N array pointer
	ADD  EBX, dwDllBase
	XOR  EAX, EAX				           ; EAX AddressOfNames Index

;.......................................................  EAX Free
;.......................................................
;.......................................................  REPEAT - BREAK - UNTIL

;repeatstart:
;	lea eax, [.msg]
;	invoke GetMessage, eax, NULL, 0, 0
;	cmp eax, 0
;	jb UNTIL
;	je .BREAK
;	lea eax, [.msg]
;	invoke TranslateMessage, eax
;	lea eax, [.msg]
;	invoke DispatchMessage, eax

;	jmp repeatstart

;	.BREAK:
;		invoke MessageBoxA, 0, Error, Saliendo, MB_OK
;.fin .UNTIL:
;		mov eax, dword[.msg+MSG.wParam]



; repeatstart:
; cmp eax,1
; jne UNTIL_exitloop
; code goes here
; jmp repeatstart
; UNTIL_exitloop:


	.REPEAT

	   MOV	EDI, [EBX]
	   ADD	EDI, dwDllBase
	   MOV	ESI, [szApi]      ;  szApi
	   PUSH ECX				;  save the api string length
	   REPZ CMPSB

	   .IF ZERO?
	      .BREAK
	   .ENDIF

	   POP	ECX
	   ADD	EBX, 4
	   INC	EAX
	.UNTIL EAX == [edx+IMAGE_EXPORT_DIRECTORY.AddressOfNames]


;;  This has been commented out and it still works... But yOda coded it for a reason
;;  I need to know why instead of kust using this short cut... Thank you

;; .REPEAT
;; .BREAK
;; .UNTIL EAX == IMAGE_EXPORT_DIRECTORY.AddressOfNames[edx]


;................................................................   find 
;................................................................   corresponding
;................................................................   Ordinal
_empty:
	MOV  ESI, [edx+IMAGE_EXPORT_DIRECTORY.AddressOfNameOrdinals]

	ADD  ESI, dwDllBase
	PUSH EDX			; save the export table pointer
	MOV  EBX, 2
	XOR  EDX, EDX
	MUL  EBX
	POP  EDX
	ADD  EAX, ESI
	XOR  ECX, ECX
	MOV  WORD PTR CX, [EAX] 				   ; ECX -> Api Ordinal

;.......................................................   get address of api
 MOV  EDI, [edx+IMAGE_EXPORT_DIRECTORY.AddressOfFunctions]
	
	XOR  EDX, EDX
	MOV  EBX, 4
	MOV  EAX, ECX
	MUL  EBX
	ADD  EAX, dwDllBase
	ADD  EAX, EDI
	MOV  EAX, [EAX]
	ADD  EAX, dwDllBase
	JMP  @@ExitProc
	
	ASSUME EDX : NOTHING	
		
   @@BadExit:
	XOR  EAX, EAX	
   @@ExitProc:
	; shutdown SEH frame
	POP  FS:[0]
	ADD  ESP, 4
	RET
GetProcAddr ENDP

SehHandler PROC C pExcept:DWORD,pFrame:DWORD,pContext:DWORD,pDispatch:DWORD
	MOV  EAX, pContext
	ASSUME EAX : PTR CONTEXT
	PUSH SEH.SaveEip
	POP  [EAX].regEip
	PUSH SEH.OrgEsp
	POP  [EAX].regEsp
	PUSH SEH.OrgEbp
	POP  [EAX].regEbp
	MOV  EAX, ExceptionContinueExecution
	RET
SehHandler ENDP


; ######################################################
; ######################################################
; ######################################################
; ######################################################


; ######################################################
; ######################################################
; ######################################################
; ######################################################

GetKernelBase PROC dwTopStack : DWORD

	MOV  EDI, dwTopStack		       ; start the search
	AND  EDI, 0FFFF0000h		       ; wipe the LOWORD !

 whilestart:

nop
nop

	   .IF WORD PTR [EDI] == 5A4Dh ; IMAGE_DOS_SIGNATURE

		    cmp WORD PTR [EDI], 5A4Dh ; IMAGE_DOS_SIGNATURE

	jne Not_Below	; ENDWHILE

	      MOV  ESI, EDI
	      ADD  ESI, [ESI+03Ch]
		   cmp esi, 4550h ; .IF  DWORD PTR [ESI] == IMAGE_NT_SIGNATURE
	jne whilestart		  ;  BREAK

	   .ENDIF

; ............................................................
	   SUB	EDI, 010000h

		cmp EDI, MIN_KERNEL_SEARCH_BASE     ; .IF EDI < 
	jnb Not_Below

		    MOV  EDI, 0BFF70000h
; ............................................................

 Not_Below:

		XCHG EAX, EDI
 No_if:

		RET
GetKernelBase ENDP


end main